/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.common.part;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jp.mosp.common.CommonConst;
import jp.mosp.common.dto.CmComponentDto;
import jp.mosp.common.dto.HumanBasisDtoInterface;
import jp.mosp.common.part.ComponentPart;
import jp.mosp.common.part.PartInfo;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.dao.MSyozokuDao;
import jp.mosp.kintai.common.dto.MSyozokuDto;

/**
 * 所属に関するPartクラス
 * @author yoshida
 *	@version	0.0.2
 */
public class SectionPart extends KintaiBasePart {
	
	/**
	 * コンストラクタ
	 */
	public SectionPart() {
		super();
	}
	
	/**
	 * コンストラクタ
	 * @param partInfo 	Partを利用する際に必要な情報
	 */
	public SectionPart(PartInfo partInfo) {
		super(partInfo);
	}
	

	/**
	 * MSyozokuDaoインスタンス
	 */
	private MSyozokuDao	syozokuDao;
	

	/**
	 * M_SYOZOKUテーブル用のDAO取得
	 * @return	初期化済みMSyozokuDaoインスタンス
	 * @throws Exception 例外処理が発生した場合
	 */
	public MSyozokuDao getMSyozokuDao() throws Exception {
		if (VariousUtil.isNull(syozokuDao)) {
			syozokuDao = (MSyozokuDao)getPreparedDao(MSyozokuDao.class.getCanonicalName());
		}
		return syozokuDao;
	}
	
	/**
	 * 所属情報取得(M_SYOZOKU)
	 * @param sCode 情報取得対象所属コード
	 * @return 所属情報(MSyozokuDto)
	 * @throws Exception  例外処理が発生した場合
	 */
	public MSyozokuDto getSectionInfo(String sCode) throws Exception {
		// 情報の取得
		return getMSyozokuDao().findForKey(sCode);
	}
	
	/**
	 * 所属情報取得(M_SYOZOKU)
	 * @param sCode 情報取得対象所属コード
	 * @return 所属名称
	 * @throws Exception  例外処理が発生した場合
	 */
	public String getSectionName(String sCode) throws Exception {
		MSyozokuDto dto = getSectionInfo(sCode);
		if (VariousUtil.isNotNull(dto)) {
			return dto.getSName();
		}
		return "";
	}
	
	/**
	 * 所属コード取得
	 * @param kCode 取得対象社員コード
	 * @return 所属コード
	 * @throws Exception 例外処理が発生した場合
	 */
	public String getBelongSectionCode(String kCode) throws Exception {
		// 人事基本情報取得
		HumanBasisDtoInterface mKihonDto = part().human().getBasisInfo(kCode);
		if (VariousUtil.isNotNull(mKihonDto)) {
			return mKihonDto.getSCode();
		}
		return "";
	}
	
	/**
	 * 所属名称取得
	 * @param kCode 取得対象社員コード
	 * @return 所属名称
	 * @throws Exception 例外処理が発生した場合
	 */
	public String getBelongSectionName(String kCode) throws Exception {
		return getSectionName(getBelongSectionCode(kCode));
	}
	
	/**
	 * 所属コード取得(M_SYOZOKU)
	 * @return 所属コードリスト
	 * @throws Exception  例外処理が発生した場合
	 */
	public String[][] getSectionArrayAll() throws Exception {
		// 情報の取得
		// 配列の作成
		return getSectionArray(findAll());
	}
	
	/**
	 * 所属コード取得(利用可能…所属のみ)(M_SYOZOKU)
	 * @return 所属コードリスト
	 * @throws Exception 例外処理が発生した場合
	 */
	public String[][] getSectionArrayForManager() throws Exception {
		// 配列の作成
		return getSectionArray(getSectionListForManager());
	}
	
	/**
	 * 所属コード取得(利用可能…所属のみ)(M_SYOZOKU)
	 * @since	0.0.2
	 * @return 所属コードリスト
	 * @throws Exception 例外処理が発生した場合
	 */
	public List<MSyozokuDto> getSectionListForManager() throws Exception {
		// 情報の取得
		return findForCondition(part().human().getBasisInfoOfUser().getSCode());
	}
	
	/**
	 * 所属コード取得(利用可能…権限により変化)(M_SYOZOKU)
	 * @return 所属コードリスト
	 * @throws Exception 例外処理が発生した場合
	 */
	public String[][] getSectionArrayForHuman() throws Exception {
		// 情報の取得
		List<MSyozokuDto> listSection;
		// 操作権限確認		
		if (part().authority().hasHumanAuth()) {
			listSection = findAll();
		} else {
			listSection = getSectionListForManager();
		}
		// 配列の作成
		return getSectionArray(listSection);
	}
	
	/**
	 * 所属コード取得(所属範囲により変化)(M_SYOZOKU)
	 * @return 所属コード配列
	 * @throws Exception 例外処理が発生した場合
	 */
	public String[][] getSectionScopeArrayForPayroll() throws Exception {
		return getSectionArray(getSectionScopeListForPayroll());
	}
	
	/**
	 * 所属コード取得(所属範囲により変化)(M_SYOZOKU)
	 * @since	0.0.2
	 * @return 所属コードリスト
	 * @throws Exception 例外処理が発生した場合
	 */
	public List<MSyozokuDto> getSectionScopeListForPayroll() throws Exception {
		CmComponentDto componentDto = part().menu().getPayrollComponentInfo();
		List<MSyozokuDto> listSection = null;
		// プルダウン設定
		if (ComponentPart.isBelongingSection(componentDto)) {
			listSection = getSectionListForManager();
		} else if (ComponentPart.isSelectSection(componentDto)) {
			listSection = findAll();
		} else if (ComponentPart.isAllSection(componentDto)) {
			listSection = findAll();
			MSyozokuDto dto = new MSyozokuDto();
			dto.setSCode(CommonConst.NAM_COMMON_STRING_INITIAL_VALUE);
			dto.setSName(CommonConst.NAM_ALL_SECTION);
			listSection.add(0, dto);
		}
		return listSection;
	}
	
	/**
	 * 所属リスト取得(M_SYOZOKU)
	 * @return 所属コードリスト
	 * @throws Exception 例外処理が発生した場合
	 */
	public Map<String, MSyozokuDto> getSectionMap() throws Exception {
		// 情報の取得
		List<MSyozokuDto> listSection = findAll();
		// 配列の作成
		HashMap<String, MSyozokuDto> map = new HashMap<String, MSyozokuDto>();
		for (MSyozokuDto dto : listSection) {
			map.put(dto.getSCode(), dto);
		}
		return map;
	}
	
	/**
	 * 全所属コード配列取得
	 * @return	所属コード配列
	 * @throws Exception 例外処理が発生した場合
	 */
	public String[] getSectionCodeArrayAll() throws Exception {
		List<MSyozokuDto> listSection = findAll();
		String[] arySectionCode = new String[listSection.size()];
		int i = 0;
		for (MSyozokuDto dto : listSection) {
			arySectionCode[i] = dto.getSCode();
			i++;
		}
		return arySectionCode;
	}
	
	/**
	 * 対象所属コードリスト取得
	 * @since	0.0.2
	 * @param sCode		対象所属コード
	 * @return	所属情報リスト
	 * @throws Exception 例外処理が発生した場合
	 */
	public List<MSyozokuDto> findForCondition(String sCode) throws Exception {
		return getMSyozokuDao().findForCondition(sCode);
	}
	
	/**
	 * 全所属コードリスト取得
	 * @since	0.0.2
	 * @return	所属情報リスト
	 * @throws Exception 例外処理が発生した場合
	 */
	public List<MSyozokuDto> findAll() throws Exception {
		return getMSyozokuDao().findAll();
	}
	
	/**
	 * 所属情報リスト配列変換
	 * @since	0.0.2
	 * @param list	対象所属情報リスト
	 * @return	所属情報配列
	 */
	public static String[][] getSectionArray(List<MSyozokuDto> list) {
		String[][] arySection = new String[0][0];
		if (VariousUtil.isNotNull(list)) {
			arySection = new String[list.size()][2];
			int i = 0;
			for (MSyozokuDto dto : list) {
				arySection[i][0] = dto.getSCode();
				arySection[i][1] = dto.getSName();
				i++;
			}
		}
		return arySection;
	}
	
}
